--- django.po.mksoft	2010-03-23 01:57:59.000000000 +0200
+++ django.po	2010-03-24 02:38:04.000000000 +0200
@@ -5,15 +5,16 @@
 msgstr ""
 "Project-Id-Version: Django\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2010-03-17 15:44+0200\n"
-"PO-Revision-Date: 2010-03-17 16:53+0200\n"
-"Last-Translator: Meir Kriheli <meir@mksoft.co.il>\n"
+"POT-Creation-Date: 2010-03-24 02:37+0200\n"
+"PO-Revision-Date: 2010-03-24 02:11+0200\n"
+"Last-Translator: Shai Berger <shai@platonix.com>\n"
 "Language-Team: Django-i18n <django-i18n@googlegroups.com>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n != 1);\n"
 "X-Poedit-Bookmarks: -1,988,-1,-1,-1,-1,-1,-1,-1,-1\n"
+"X-Generator: Lokalize 1.0\n"
 
 #: conf/global_settings.py:44
 msgid "Arabic"
@@ -97,7 +98,7 @@
 
 #: conf/global_settings.py:64
 msgid "Galician"
-msgstr "גאליצית"
+msgstr "גאליציאנית"
 
 #: conf/global_settings.py:65
 msgid "Hebrew"
@@ -135,9 +136,10 @@
 msgid "Khmer"
 msgstr "חמר"
 
+# זו שפה הודית, אין קשר לקנדה המדינה
 #: conf/global_settings.py:74
 msgid "Kannada"
-msgstr "קנדית"
+msgstr "קאנאדה"
 
 #: conf/global_settings.py:75
 msgid "Korean"
@@ -242,16 +244,16 @@
 #: contrib/admin/actions.py:52
 #, python-format
 msgid "Successfully deleted %(count)d %(items)s."
-msgstr "%(count)d %(items)s  היו נמחקו בהצלחה."
+msgstr "%(count)d %(items)s  נמחקו בהצלחה."
 
-#: contrib/admin/actions.py:59 contrib/admin/options.py:1101
+#: contrib/admin/actions.py:59 contrib/admin/options.py:1097
 msgid "Are you sure?"
 msgstr "האם את/ה בטוח/ה ?"
 
 #: contrib/admin/actions.py:77
 #, python-format
 msgid "Delete selected %(verbose_name_plural)s"
-msgstr "מחק את ה%(verbose_name_plural)s שבחרת"
+msgstr "מחק %(verbose_name_plural)s שנבחרו"
 
 #: contrib/admin/filterspecs.py:44
 #, python-format
@@ -331,7 +333,7 @@
 msgid "log entries"
 msgstr "רישומי יומן"
 
-#: contrib/admin/options.py:139 contrib/admin/options.py:154
+#: contrib/admin/options.py:140 contrib/admin/options.py:155
 msgid "None"
 msgstr "ללא"
 
@@ -342,7 +344,7 @@
 
 #: contrib/admin/options.py:558 contrib/admin/options.py:568
 #: contrib/comments/templates/comments/preview.html:16 db/models/base.py:840
-#: forms/models.py:553
+#: forms/models.py:556
 msgid "and"
 msgstr "ו"
 
@@ -390,62 +392,62 @@
 "The %(name)s \"%(obj)s\" was added successfully. You may edit it again below."
 msgstr "הוספת %(name)s \"%(obj)s\" בוצעה בהצלחה. ניתן לערוך אותו שוב מתחת."
 
-#: contrib/admin/options.py:743
+#: contrib/admin/options.py:739
 msgid ""
 "Items must be selected in order to perform actions on them. No items have "
 "been changed."
 msgstr "יש לסמן פריטים כדי לבצע עליהם פעולות. לא שונו פריטים."
 
-#: contrib/admin/options.py:761
+#: contrib/admin/options.py:757
 msgid "No action selected."
 msgstr "לא נבחרה פעולה."
 
-#: contrib/admin/options.py:841
+#: contrib/admin/options.py:837
 #, python-format
 msgid "Add %s"
 msgstr "הוספת %s"
 
-#: contrib/admin/options.py:867 contrib/admin/options.py:1081
+#: contrib/admin/options.py:863 contrib/admin/options.py:1077
 #, python-format
 msgid "%(name)s object with primary key %(key)r does not exist."
 msgstr "הפריט %(name)s עם המפתח הראשי %(key)r אינו קיים."
 
-#: contrib/admin/options.py:932
+#: contrib/admin/options.py:928
 #, python-format
 msgid "Change %s"
 msgstr "שינוי %s"
 
-#: contrib/admin/options.py:977
+#: contrib/admin/options.py:973
 msgid "Database error"
 msgstr "שגיאת בסיס נתונים"
 
-#: contrib/admin/options.py:1013
+#: contrib/admin/options.py:1009
 #, python-format
 msgid "%(count)s %(name)s was changed successfully."
 msgid_plural "%(count)s %(name)s were changed successfully."
 msgstr[0] "שינוי %(count)s %(name)s בהצלחה."
 msgstr[1] "שינוי %(count)s %(name)s בהצלחה."
 
-#: contrib/admin/options.py:1040
+#: contrib/admin/options.py:1036
 #, python-format
 msgid "of %(count)d selected"
 msgid_plural "of %(count)d selected"
 msgstr[0] "מתוך %(count)d נבחר"
 msgstr[1] "מתוך %(count)d נבחרו"
 
-#: contrib/admin/options.py:1042
+#: contrib/admin/options.py:1038
 #, python-format
 msgid "%(total_count)s selected"
 msgid_plural "All %(total_count)s selected"
 msgstr[0] "%(total_count)s נבחר"
 msgstr[1] "כל ה-%(total_count)s נבחרו"
 
-#: contrib/admin/options.py:1094
+#: contrib/admin/options.py:1090
 #, python-format
 msgid "The %(name)s \"%(obj)s\" was deleted successfully."
 msgstr "מחיקת %(name)s \"%(obj)s\" בוצעה בהצלחה."
 
-#: contrib/admin/options.py:1131
+#: contrib/admin/options.py:1127
 #, python-format
 msgid "Change history: %s"
 msgstr "היסטוריית שינוי: %s"
@@ -895,7 +897,7 @@
 "Please enter your old password, for security's sake, and then enter your new "
 "password twice so we can verify you typed it in correctly."
 msgstr ""
-"נא להזין את סיסמתך הישנה, למען האבטחה, ולאחר מכן את סיסמתך החדשה פעמיים כדי "
+"נא להזין את סיסמתך הישנה, לצרכי אבטחה, ולאחר מכן את סיסמתך החדשה פעמיים כדי "
 "שנוכל לוודא שהקלדת אותה כראוי."
 
 #: contrib/admin/templates/registration/password_change_form.html:27
@@ -1429,7 +1431,7 @@
 #: contrib/comments/feeds.py:23
 #, python-format
 msgid "Latest comments on %(site_name)s"
-msgstr "ההערות האחרונות על %(site_name)s"
+msgstr "התגובות האחרונות על %(site_name)s"
 
 #: contrib/comments/forms.py:93
 msgid "Name"
@@ -1440,7 +1442,7 @@
 msgstr "כתובת דוא\"ל"
 
 #: contrib/comments/forms.py:95 contrib/flatpages/admin.py:8
-#: contrib/flatpages/models.py:7 db/models/fields/__init__.py:1121
+#: contrib/flatpages/models.py:7 db/models/fields/__init__.py:1128
 msgid "URL"
 msgstr "URL"
 
@@ -1458,7 +1460,7 @@
 #: contrib/comments/forms.py:182
 msgid ""
 "If you enter anything in this field your comment will be treated as spam"
-msgstr "אם יוזן משהו בשדה היחס לתגובתך יהיה כמו לספאם"
+msgstr "אם יוזן משהו בשדה זה תגובתך תטופל כספאם"
 
 #: contrib/comments/models.py:22 contrib/contenttypes/models.py:81
 msgid "content type"
@@ -1489,18 +1491,18 @@
 msgid "date/time submitted"
 msgstr "תאריך/שעת הגשה"
 
-#: contrib/comments/models.py:60 db/models/fields/__init__.py:916
+#: contrib/comments/models.py:60 db/models/fields/__init__.py:923
 msgid "IP address"
 msgstr "כתובת IP"
 
 #: contrib/comments/models.py:61
 msgid "is public"
-msgstr "ציבורי"
+msgstr "פומבי "
 
 #: contrib/comments/models.py:62
 msgid ""
 "Uncheck this box to make the comment effectively disappear from the site."
-msgstr "ביטול סימון תיבה תעלים בפועל את התגובה מהאתר"
+msgstr "ביטול סימון התיבה יעלים בפועל את התגובה מהאתר"
 
 #: contrib/comments/models.py:64
 msgid "is removed"
@@ -1511,7 +1513,8 @@
 "Check this box if the comment is inappropriate. A \"This comment has been "
 "removed\" message will be displayed instead."
 msgstr ""
-"יש לסמן תיבה זו עבור תגובה לא נאותה. הודעת \"תגובה זו נמחקה\" תוצג במקום."
+"יש לסמן תיבה זו עבור תגובה לא נאותה. הודעת \"תגובה זו נמחקה\" תוצג במקום "
+"התגובה."
 
 #: contrib/comments/models.py:77
 msgid "comments"
@@ -1521,13 +1524,13 @@
 msgid ""
 "This comment was posted by an authenticated user and thus the name is read-"
 "only."
-msgstr "הודעה זו נשלחה ע\"י משתמש מחובר לכן השם הוא לקריאה בלבד."
+msgstr "הודעה זו נשלחה ע\"י משתמש מחובר לכן השם אינו ניתן לשינוי."
 
 #: contrib/comments/models.py:128
 msgid ""
 "This comment was posted by an authenticated user and thus the email is read-"
 "only."
-msgstr "הודעה זו נשלחה ע\"י משתמש מחובר לכן כתובת הדוא\"ל לקריאה בלבד."
+msgstr "הודעה זו נשלחה ע\"י משתמש מחובר לכן כתובת הדוא\"ל אינה ניתנת לשינוי."
 
 #: contrib/comments/models.py:153
 #, python-format
@@ -1566,7 +1569,7 @@
 
 #: contrib/comments/templates/comments/approve.html:7
 msgid "Really make this comment public?"
-msgstr "באמת הופכים את התגובה הציבורית?"
+msgstr "באמת להפוך את התגובה לפומבית?"
 
 #: contrib/comments/templates/comments/approve.html:12
 msgid "Approve"
@@ -1574,34 +1577,34 @@
 
 #: contrib/comments/templates/comments/approved.html:4
 msgid "Thanks for approving"
-msgstr "תודה על השימוש באתר שלנו!"
+msgstr "תודה על אישור התגובה"
 
 #: contrib/comments/templates/comments/approved.html:7
 #: contrib/comments/templates/comments/deleted.html:7
 #: contrib/comments/templates/comments/flagged.html:7
 msgid ""
 "Thanks for taking the time to improve the quality of discussion on our site"
-msgstr "תודה שהקדשת מזמנך כדי לשפר את האתר שלנו"
+msgstr "תודה על שהקדשת מזמנך כדי לשפר את איכות הדיון באתר שלנו"
 
 #: contrib/comments/templates/comments/delete.html:4
 msgid "Remove a comment"
-msgstr "הסר הערה"
+msgstr "הסר תגובה"
 
 #: contrib/comments/templates/comments/delete.html:7
 msgid "Really remove this comment?"
-msgstr "באמת להסיר את הערה זו?"
+msgstr "באמת להסיר תגובה זו?"
 
 #: contrib/comments/templates/comments/deleted.html:4
 msgid "Thanks for removing"
-msgstr "תודה על הסרת"
+msgstr "תודה על ההסרה"
 
 #: contrib/comments/templates/comments/flag.html:4
 msgid "Flag this comment"
-msgstr "סמן את הערה זו"
+msgstr "סמן תגובה זו"
 
 #: contrib/comments/templates/comments/flag.html:7
 msgid "Really flag this comment?"
-msgstr "באמת, סמן את הערה זו?"
+msgstr "באמת לסמן תגובה זו?"
 
 #: contrib/comments/templates/comments/flag.html:12
 msgid "Flag"
@@ -1609,7 +1612,7 @@
 
 #: contrib/comments/templates/comments/flagged.html:4
 msgid "Thanks for flagging"
-msgstr "תודה לציון"
+msgstr "תודה על הסימון"
 
 #: contrib/comments/templates/comments/form.html:17
 #: contrib/comments/templates/comments/preview.html:32
@@ -1693,8 +1696,8 @@
 "Example: 'flatpages/contact_page.html'. If this isn't provided, the system "
 "will use 'flatpages/default.html'."
 msgstr ""
-"דוגמא: 'flatpages/contact_page.html'. אם זה לא צויין, המערכת תשתמש "
-"ב-'flatpages/default.html'."
+"דוגמא: 'flatpages/contact_page.html'. אם לא צויין, המערכת תשתמש ב-'flatpages/"
+"default.html'."
 
 #: contrib/flatpages/models.py:13
 msgid "registration required"
@@ -4410,7 +4413,7 @@
 msgid "Enter a valid IPv4 address."
 msgstr "יש להזין כתובת IPv4 חוקית."
 
-#: core/validators.py:129 db/models/fields/__init__.py:598
+#: core/validators.py:129 db/models/fields/__init__.py:599
 msgid "Enter only digits separated by commas."
 msgstr "יש להזין רק ספרות מופרדות בפסיקים."
 
@@ -4455,122 +4458,122 @@
 msgid "%(model_name)s with this %(field_label)s already exists."
 msgstr "%(model_name)s·עם·%(field_label)s·זה קיימת כבר."
 
-#: db/models/fields/__init__.py:62
+#: db/models/fields/__init__.py:63
 #, python-format
 msgid "Value %r is not a valid choice."
 msgstr "ערך %r אינו אפשרות חוקית."
 
-#: db/models/fields/__init__.py:63
+#: db/models/fields/__init__.py:64
 msgid "This field cannot be null."
-msgstr "שדה זה אינו יכול להכיל null."
+msgstr "שדה זה אינו יכול להיות ריק."
 
-#: db/models/fields/__init__.py:64
+#: db/models/fields/__init__.py:65
 msgid "This field cannot be blank."
 msgstr "שדה זה אינו יכול להיות ריק."
 
-#: db/models/fields/__init__.py:69
+#: db/models/fields/__init__.py:70
 #, python-format
 msgid "Field of type: %(field_type)s"
 msgstr "שדה מסוג: %(field_type)s"
 
-#: db/models/fields/__init__.py:477 db/models/fields/__init__.py:878
-#: db/models/fields/__init__.py:981 db/models/fields/__init__.py:992
-#: db/models/fields/__init__.py:1019
+#: db/models/fields/__init__.py:478 db/models/fields/__init__.py:879
+#: db/models/fields/__init__.py:988 db/models/fields/__init__.py:999
+#: db/models/fields/__init__.py:1026
 msgid "Integer"
 msgstr "מספר שלם"
 
-#: db/models/fields/__init__.py:481 db/models/fields/__init__.py:876
+#: db/models/fields/__init__.py:482 db/models/fields/__init__.py:877
 msgid "This value must be an integer."
 msgstr "ערך זה חייב להיות מספר שלם."
 
-#: db/models/fields/__init__.py:516
+#: db/models/fields/__init__.py:517
 msgid "This value must be either True or False."
 msgstr "ערך זה חייב להיות אמת או שקר."
 
-#: db/models/fields/__init__.py:518
+#: db/models/fields/__init__.py:519
 msgid "Boolean (Either True or False)"
 msgstr "בוליאני (אמת או שקר)"
 
-#: db/models/fields/__init__.py:565 db/models/fields/__init__.py:1002
+#: db/models/fields/__init__.py:566 db/models/fields/__init__.py:1009
 #, python-format
 msgid "String (up to %(max_length)s)"
 msgstr "מחרוזת (עד %(max_length)s תווים)"
 
-#: db/models/fields/__init__.py:593
+#: db/models/fields/__init__.py:594
 msgid "Comma-separated integers"
 msgstr "מספרים שלמים מופרדים בפסיקים"
 
-#: db/models/fields/__init__.py:607
+#: db/models/fields/__init__.py:608
 msgid "Date (without time)"
 msgstr "תאריך (ללא שעה)"
 
-#: db/models/fields/__init__.py:611
+#: db/models/fields/__init__.py:612
 msgid "Enter a valid date in YYYY-MM-DD format."
 msgstr "יש להזין תאריך במבנה YYYY-MM-DD."
 
-#: db/models/fields/__init__.py:612
+#: db/models/fields/__init__.py:613
 #, python-format
 msgid "Invalid date: %s"
 msgstr "תאריך שגוי: %s"
 
-#: db/models/fields/__init__.py:693
+#: db/models/fields/__init__.py:694
 msgid "Enter a valid date/time in YYYY-MM-DD HH:MM[:ss[.uuuuuu]] format."
 msgstr "נא להזין תאריך/שעה חוקיים בתחביר YYYY-MM-DD HH:MM[:ss[.uuuuuu]]."
 
-#: db/models/fields/__init__.py:695
+#: db/models/fields/__init__.py:696
 msgid "Date (with time)"
 msgstr "תאריך (כולל שעה)"
 
-#: db/models/fields/__init__.py:761
+#: db/models/fields/__init__.py:762
 msgid "This value must be a decimal number."
 msgstr "ערך זה חייב להיות מספר עשרוני."
 
-#: db/models/fields/__init__.py:763
+#: db/models/fields/__init__.py:764
 msgid "Decimal number"
 msgstr "מספר עשרוני"
 
-#: db/models/fields/__init__.py:818
+#: db/models/fields/__init__.py:819
 msgid "E-mail address"
 msgstr "כתובת דוא\"ל"
 
-#: db/models/fields/__init__.py:825 db/models/fields/files.py:220
+#: db/models/fields/__init__.py:826 db/models/fields/files.py:220
 #: db/models/fields/files.py:331
 msgid "File path"
 msgstr "נתיב קובץ"
 
-#: db/models/fields/__init__.py:848
+#: db/models/fields/__init__.py:849
 msgid "This value must be a float."
 msgstr "על הערך הזה להיות ערך מספר עשרוני."
 
-#: db/models/fields/__init__.py:850
+#: db/models/fields/__init__.py:851
 msgid "Floating point number"
 msgstr "מספר עשרוני"
 
-#: db/models/fields/__init__.py:903
+#: db/models/fields/__init__.py:910
 msgid "Big (8 byte) integer"
 msgstr "מספר שלם גדול (8 בתים)"
 
-#: db/models/fields/__init__.py:932
+#: db/models/fields/__init__.py:939
 msgid "This value must be either None, True or False."
 msgstr "ערך זה חייב להיות כלום, אמת או שקר."
 
-#: db/models/fields/__init__.py:934
+#: db/models/fields/__init__.py:941
 msgid "Boolean (Either True, False or None)"
 msgstr "בוליאני (אמת, שקר או כלום)"
 
-#: db/models/fields/__init__.py:1025
+#: db/models/fields/__init__.py:1032
 msgid "Text"
 msgstr "טקסט"
 
-#: db/models/fields/__init__.py:1041
+#: db/models/fields/__init__.py:1048
 msgid "Time"
 msgstr "זמן"
 
-#: db/models/fields/__init__.py:1045
+#: db/models/fields/__init__.py:1052
 msgid "Enter a valid time in HH:MM[:ss[.uuuuuu]] format."
 msgstr "נא להזין זמן חוקי בתחביר HH:MM[:ss[.uuuuuu]]."
 
-#: db/models/fields/__init__.py:1129
+#: db/models/fields/__init__.py:1136
 msgid "XML text"
 msgstr "טקסט XML"
 
@@ -4673,7 +4676,7 @@
 msgid "Select a valid choice. %(value)s is not one of the available choices."
 msgstr "יש לבחור אפשרות חוקית. %(value)s אינו בין האפשרויות הזמינות."
 
-#: forms/fields.py:660 forms/fields.py:722 forms/models.py:986
+#: forms/fields.py:660 forms/fields.py:722 forms/models.py:989
 msgid "Enter a list of values."
 msgstr "יש להזין רשימת ערכים"
 
@@ -4681,46 +4684,46 @@
 msgid "Order"
 msgstr "מיון"
 
-#: forms/models.py:547
+#: forms/models.py:550
 #, python-format
 msgid "Please correct the duplicate data for %(field)s."
-msgstr "נא לתקן את הערכים כפולים ל%(field)s."
+msgstr "נא לתקן את הערכים הכפולים ל%(field)s."
 
-#: forms/models.py:551
+#: forms/models.py:554
 #, python-format
 msgid "Please correct the duplicate data for %(field)s, which must be unique."
-msgstr "נא לתקן את הערכים כפולים ל%(field)s, זה חייב להיות ייחודי."
+msgstr "נא לתקן את הערכים הכפולים ל%(field)s, שערכים בו חייבים להיות ייחודיים."
 
-#: forms/models.py:557
+#: forms/models.py:560
 #, python-format
 msgid ""
 "Please correct the duplicate data for %(field_name)s which must be unique "
 "for the %(lookup)s in %(date_field)s."
 msgstr ""
-"נא לתקן את הערכים כפולים %(field_name)s, זה חייב להיות ייחודי ל%(lookup)s של "
-"%(date_field)s."
+"נא לתקן את הערכים הכפולים %(field_name)s, שחייבים להיות ייחודיים ל%(lookup)s "
+"של %(date_field)s."
 
-#: forms/models.py:565
+#: forms/models.py:568
 msgid "Please correct the duplicate values below."
-msgstr "נא לתקן את הערכים כפולים מתחת."
+msgstr "נא לתקן את הערכים הכפולים למטה."
 
-#: forms/models.py:839
+#: forms/models.py:842
 msgid "The inline foreign key did not match the parent instance primary key."
-msgstr "הרצופות מפתח זר לא תאם את האב מופע המפתח העיקרי."
+msgstr "המפתח הזר ה-inline לא התאים למפתח הראשי של האב."
 
-#: forms/models.py:905
+#: forms/models.py:908
 msgid "Select a valid choice. That choice is not one of the available choices."
-msgstr "יש לבחור אפשרות חוקית; '%(data)s' אינו בין %(choices)s."
+msgstr "יש לבחור אפשרות חוקית; אפשרות זו אינה אחת מהזמינות."
 
-#: forms/models.py:987
+#: forms/models.py:990
 #, python-format
 msgid "Select a valid choice. %s is not one of the available choices."
 msgstr "יש לבחור אפשרות חוקית. %s אינו בין האפשרויות הזמינות."
 
-#: forms/models.py:989
+#: forms/models.py:992
 #, python-format
 msgid "\"%s\" is not a valid value for a primary key."
-msgstr "\"%s\" איננו חוקי כמקש עיקרי."
+msgstr "\"%s\" איננו חוקי כמפתח ראשי."
 
 #: template/defaultfilters.py:781
 msgid "yes,no,maybe"
@@ -4730,7 +4733,7 @@
 #, python-format
 msgid "%(size)d byte"
 msgid_plural "%(size)d bytes"
-msgstr[0] "%(size)d בית"
+msgstr[0] "בית %(size)d "
 msgstr[1] "%(size)d בתים"
 
 #: template/defaultfilters.py:814
@@ -4770,7 +4773,7 @@
 
 #: utils/dateformat.py:100
 msgid "noon"
-msgstr "צהריים"
+msgstr "12 בצהריים"
 
 #: utils/dates.py:6
 msgid "Monday"
@@ -5020,11 +5023,11 @@
 
 #: utils/translation/trans_real.py:535
 msgid "YEAR_MONTH_FORMAT"
-msgstr "d.m.Y"
+msgstr "m.Y"
 
 #: utils/translation/trans_real.py:536
 msgid "MONTH_DAY_FORMAT"
-msgstr "d.m.Y"
+msgstr "d.m"
 
 #: views/generic/create_update.py:115
 #, python-format