Index: django/contrib/admin/options.py
===================================================================
--- django/contrib/admin/options.py	(revision 12814)
+++ django/contrib/admin/options.py	(working copy)
@@ -732,7 +732,7 @@
 
             # Get the list of selected PKs. If nothing's selected, we can't
             # perform an action on it, so bail. Except we want to perform
-            # the action explicitely on all objects.
+            # the action explicitly on all objects.
             selected = request.POST.getlist(helpers.ACTION_CHECKBOX_NAME)
             if not selected and not select_across:
                 # Reminder that something needs to be selected or nothing will happen
@@ -756,6 +756,7 @@
         else:
             msg = _("No action selected.")
             self.message_user(request, msg)
+            return None
 
     @csrf_protect_m
     @transaction.commit_on_success
@@ -974,20 +975,41 @@
             return HttpResponseRedirect(request.path + '?' + ERROR_FLAG + '=1')
 
         # If the request was POSTed, this might be a bulk action or a bulk edit.
-        # Try to look up an action or confirmation first, but if this isn't an
-        # action the POST will fall through to the bulk edit check, below.
-        if actions and request.method == 'POST' and (helpers.ACTION_CHECKBOX_NAME in request.POST or 'index' in request.POST):
-            response = self.response_action(request, queryset=cl.get_query_set())
-            if response:
-                return response
+        # Try to look up an action or confirmation first, but if this isn't an action the POST
+        # will fall through to the bulk edit check, below.
 
+        action_failed = False
+
+        # Actions with no confirmation
+        if actions and request.method == 'POST' and 'index' in request.POST and '_save' not in request.POST:
+            if len(request.POST.get(helpers.ACTION_CHECKBOX_NAME, [])):
+                response = self.response_action(request, queryset=cl.get_query_set())
+                if response:
+                    return response
+                else:
+                    action_failed = True
+            else:
+                msg = _("Items must be selected in order to perform actions on them. No items have been changed.")
+                self.message_user(request, msg)
+                action_failed = True
+
+        # Actions with confirmation
+        if actions and request.method == 'POST' and helpers.ACTION_CHECKBOX_NAME in request.POST and 'index' not in request.POST and '_save' not in request.POST:
+            if len(request.POST.get(helpers.ACTION_CHECKBOX_NAME, [])):
+                response = self.response_action(request, queryset=cl.get_query_set())
+                if response:
+                    return response
+                else:
+                    action_failed = True
+
+
         # If we're allowing changelist editing, we need to construct a formset
         # for the changelist given all the fields to be edited. Then we'll
         # use the formset to validate/process POSTed data.
         formset = cl.formset = None
 
         # Handle POSTed bulk-edit data.
-        if request.method == "POST" and self.list_editable:
+        if request.method == "POST" and self.list_editable and '_save' in request.POST and not action_failed:
             FormSet = self.get_changelist_formset(request)
             formset = cl.formset = FormSet(request.POST, request.FILES, queryset=cl.result_list)
             if formset.is_valid():
Index: tests/regressiontests/admin_views/tests.py
===================================================================
--- tests/regressiontests/admin_views/tests.py	(revision 12814)
+++ tests/regressiontests/admin_views/tests.py	(working copy)
@@ -1085,6 +1085,8 @@
             "form-2-alive": "checked",
             "form-2-gender": "1",
             "form-2-id": "3",
+
+            "_save": "Save",
         }
         response = self.client.post('/test_admin/admin/admin_views/person/',
                                     data, follow=True)
@@ -1105,6 +1107,8 @@
             "form-2-alive": "checked",
             "form-2-gender": "1",
             "form-2-id": "3",
+
+            "_save": "Save",
         }
         self.client.post('/test_admin/admin/admin_views/person/', data)
 
@@ -1124,6 +1128,8 @@
             "form-1-id": "3",
             "form-1-gender": "1",
             "form-1-alive": "checked",
+
+            "_save": "Save",
         }
         self.client.post('/test_admin/admin/admin_views/person/?gender__exact=1', data)
 
@@ -1136,7 +1142,9 @@
             "form-MAX_NUM_FORMS": "0",
 
             "form-0-id": "1",
-            "form-0-gender": "1"
+            "form-0-gender": "1",
+
+            "_save": "Save",
         }
         self.client.post('/test_admin/admin/admin_views/person/?q=mauchly', data)
 
@@ -1152,6 +1160,10 @@
             "form-0-id": "2",
             "form-0-alive": "1",
             "form-0-gender": "2",
+
+            # Ensure that the form processing understands this as a list_editable "Save"
+            # and not an action "Go".
+            "_save": "Save",
         }
         response = self.client.post('/test_admin/admin/admin_views/person/', data)
         self.assertContains(response, "Grace is not a Zombie")
@@ -1166,6 +1178,8 @@
             "form-0-id": "2",
             "form-0-alive": "1",
             "form-0-gender": "2",
+
+            "_save": "Save",
         }
         response = self.client.post('/test_admin/admin/admin_views/person/', data)
         non_form_errors = response.context['cl'].formset.non_form_errors()
@@ -1201,6 +1215,10 @@
             "form-3-order": "0",
             "form-3-id": "4",
             "form-3-collector": "1",
+
+            # Ensure that the form processing understands this as a list_editable "Save"
+            # and not an action "Go".
+            "_save": "Save",
         }
         response = self.client.post('/test_admin/admin/admin_views/category/', data)
         # Successful post will redirect
@@ -1212,6 +1230,63 @@
         self.failUnlessEqual(Category.objects.get(id=3).order, 1)
         self.failUnlessEqual(Category.objects.get(id=4).order, 0)
 
+    def test_list_editable_action_submit(self):
+        # List editable changes should not be executed if the action "Go" button is
+        # used to submit the form.
+        data = {
+            "form-TOTAL_FORMS": "3",
+            "form-INITIAL_FORMS": "3",
+            "form-MAX_NUM_FORMS": "0",
+
+            "form-0-gender": "1",
+            "form-0-id": "1",
+
+            "form-1-gender": "2",
+            "form-1-id": "2",
+
+            "form-2-alive": "checked",
+            "form-2-gender": "1",
+            "form-2-id": "3",
+
+            "index": "0",
+            "_selected_action": [u'3'],
+            "action": [u'', u'delete_selected'],
+        }
+        self.client.post('/test_admin/admin/admin_views/person/', data)
+
+        self.failUnlessEqual(Person.objects.get(name="John Mauchly").alive, True)
+        self.failUnlessEqual(Person.objects.get(name="Grace Hopper").gender, 1)
+
+    def test_list_editable_action_choices(self):
+        # List editable changes should be executed if the "Save" button is
+        # used to submit the form - any action choices should be ignored.
+        data = {
+            "form-TOTAL_FORMS": "3",
+            "form-INITIAL_FORMS": "3",
+            "form-MAX_NUM_FORMS": "0",
+
+            "form-0-gender": "1",
+            "form-0-id": "1",
+
+            "form-1-gender": "2",
+            "form-1-id": "2",
+
+            "form-2-alive": "checked",
+            "form-2-gender": "1",
+            "form-2-id": "3",
+
+            "_save": "Save",
+            "_selected_action": [u'1'],
+            "action": [u'', u'delete_selected'],
+        }
+        self.client.post('/test_admin/admin/admin_views/person/', data)
+
+        self.failUnlessEqual(Person.objects.get(name="John Mauchly").alive, False)
+        self.failUnlessEqual(Person.objects.get(name="Grace Hopper").gender, 2)
+
+
+
+
 class AdminSearchTest(TestCase):
     fixtures = ['admin-views-users','multiple-child-classes']
 